using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Data;

namespace GridViewCountGeneration
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            RadGridView1.Grouping += new EventHandler<Telerik.Windows.Controls.GridView.GridView.GridViewGroupingEventArgs>(RadGridView1_Grouping);
            RadGridView1.DataLoaded += new EventHandler<EventArgs>(RadGridView1_DataLoaded);
            
            RadGridView1.ItemsSource = new Message[] { 
				new Message { Sender = "tom@hanna-barbera.com", Subject = "Cats are cool", Size = 100 },
				new Message { Sender = "jerry@hanna-barbera.com", Subject = "Mice are cool", Size = 100 },
				new Message { Sender = "spike@hanna-barbera.com", Subject = "Dogs are cool", Size = 100 }
			};
        }

        void RadGridView1_DataLoaded(object sender, EventArgs e)
        {
            if (RadGridView1.GroupDescriptors.Count > 0)
            {
                RadGridView1.ExpandAllGroups();
            }
        }

        void RadGridView1_Grouping(object sender, Telerik.Windows.Controls.GridView.GridView.GridViewGroupingEventArgs e)
        {
            if (e.GroupDescriptor != null && e.GroupDescriptor.AggregateFunctions.Count == 0)
            {
                e.GroupDescriptor.AggregateFunctions.Add(new CountFunction());
            }
        }
    }
}
